<template>
  <div class="container">
    <section>
      <div class="flex">
        <div class="max-w-xs">
          <label for="wallet" class="block text-sm font-medium text-gray-700"
            >Тикер
          </label>
          <div class="mt-1 relative rounded-md shadow-md">
            <input
              v-model="ticker"
              @keydown.enter="add"
              type="text"
              name="wallet"
              id="wallet"
              class="block w-full pr-10 border-gray-300 text-gray-900 focus:outline-none focus:ring-gray-500 focus:border-gray-500 sm:text-sm rounded-md"
              placeholder="Например DOGE"
            />
            <!-- двустороннее связывание инпута    -->
          </div>
          <div
            class="flex bg-white shadow-md p-1 rounded-md shadow-md flex-wrap"
          >
            <span
              v-for="el of arr"
              :key="el"
              class="inline-flex items-center px-2 m-1 rounded-md text-xs font-medium bg-gray-300 text-gray-800 cursor-pointer"
            >
              BTC {{ el }}
            </span>
            <!-- map по массиву объектов-->
            <span
              v-if="seen"
              class="inline-flex items-center px-2 m-1 rounded-md text-xs font-medium bg-gray-300 text-gray-800 cursor-pointer"
            >
              DOGE
            </span>
            <span
              class="inline-flex items-center px-2 m-1 rounded-md text-xs font-medium bg-gray-300 text-gray-800 cursor-pointer"
            >
              BCH
            </span>
            <span
              class="inline-flex items-center px-2 m-1 rounded-md text-xs font-medium bg-gray-300 text-gray-800 cursor-pointer"
            >
              CHD
            </span>
          </div>
          <div class="text-sm text-red-600">Такой тикер уже добавлен</div>
        </div>
      </div>
      <button
        v-on:click="add"
        type="button"
        class="my-4 inline-flex items-center py-2 px-4 border border-transparent shadow-sm text-sm leading-4 font-medium rounded-full text-white bg-gray-600 hover:bg-gray-700 transition-colors duration-300 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-gray-500"
      >
        <!-- Heroicon name: solid/mail -->
        <svg
          class="-ml-0.5 mr-2 h-6 w-6"
          xmlns="http://www.w3.org/2000/svg"
          width="30"
          height="30"
          viewBox="0 0 24 24"
          fill="#ffffff"
        >
          <path
            d="M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
          ></path>
        </svg>
        Добавить
      </button>
    </section>
    <!-- отображение блока только при наличии элементов -->
    <template v-if="currency.length">
      <!-- фильтрация с стилизованными элементами -->
      <hr class="w-full border-t border-gray-600 my-4" />
      <button
        class="my-4 mx-2 inline-flex items-center py-2 px-4 border border-transparent shadow-sm text-sm leading-4 font-medium rounded-full text-white bg-gray-600 hover:bg-gray-700 transition-colors duration-300 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-gray-500"
        @click="page = page - 1"
        v-if="page > 1"
      >
        <!-- если страница не единственная покажи кнопку назад-->
        Назад
      </button>
      <button
        class="my-4 mx-2 inline-flex items-center py-2 px-4 border border-transparent shadow-sm text-sm leading-4 font-medium rounded-full text-white bg-gray-600 hover:bg-gray-700 transition-colors duration-300 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-gray-500"
        @click="page = page + 1"
        v-if="hasNextPage"
      >
        <!-- если это не последняя страница, то оставь кнопку вперед-->
        Вперед
      </button>
      <div>
        Фильтр:<input
          class="border-2 border-solid border-gray-200 rounded-lg mx-2"
          v-model="filterString"
        />
        <!-- чтобы -->
      </div>
      <hr class="w-full border-t border-gray-600 my-4" />
      <dl class="mt-5 grid grid-cols-1 gap-5 sm:grid-cols-3">
        <!-- методы из блока компьютед не нудно вызывать-->
        <div
          v-for="el in filteredCurrency()"
          :key="el.name"
          @click="select(el)"
          :class="{
            'border-4': sel === el
          }"
          class="bg-white overflow-hidden shadow rounded-lg border-purple-800 border-solid cursor-pointer"
        >
          <!--@click="sel = el" выбранный эл закинь в сэл-->
          <!-- добавь бордер4, если сэл равен элемент-->
          <!-- :class="sel === el ? 'border-4' : ''" -->
          <div class="px-4 py-5 sm:p-6 text-center">
            <dt class="text-sm font-medium text-gray-500 truncate">
              {{ el.name }}
            </dt>
            <dd class="mt-1 text-3xl font-semibold text-gray-900">
              {{ el.price }}
            </dd>
          </div>
          <div class="w-full border-t border-gray-200"></div>
          <button
            @click.stop="deleteHandler(el)"
            class="flex items-center justify-center font-medium w-full bg-gray-100 px-4 py-4 sm:px-6 text-md text-gray-500 hover:text-gray-600 hover:bg-gray-200 hover:opacity-20 transition-all focus:outline-none"
          >
            <!-- Удаление выбранного в массиве элемента -->
            Удалить
          </button>
        </div>
      </dl>
      <hr class="w-full border-t border-gray-600 my-4" />
    </template>
    <section v-if="sel" class="relative">
      <!-- отображение блока только при наличии элементов -->
      <h3 class="text-lg leading-6 font-medium text-gray-900 my-8">
        {{ sel.name }} -
      </h3>
      <!-- отображение имени выбранного элемента -->
      <div class="flex items-end border-gray-600 border-b border-l h-64">
        <div
          v-for="(bar, i) in normalizedGraph"
          :key="i"
          :style="{ height: `${bar}%` }"
          class="bg-purple-800 border w-10"
        ></div>
        <!-- используем метод нормалайзграф вместо просто граф, так как данный метод преобразует график в ыид для вмещения его в див,
        а не рсатягивался на всю стр-->
      </div>
      <button @click="sel = null" type="button" class="absolute top-0 right-0">
        <!-- при нажатии на батон, занули сел -->
        <svg
          xmlns="http://www.w3.org/2000/svg"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svgjs="http://svgjs.com/svgjs"
          version="1.1"
          width="30"
          height="30"
          x="0"
          y="0"
          viewBox="0 0 511.76 511.76"
          style="enable-background: new 0 0 512 512"
          xml:space="preserve"
        >
          <g>
            <path
              d="M436.896,74.869c-99.84-99.819-262.208-99.819-362.048,0c-99.797,99.819-99.797,262.229,0,362.048    c49.92,49.899,115.477,74.837,181.035,74.837s131.093-24.939,181.013-74.837C536.715,337.099,536.715,174.688,436.896,74.869z     M361.461,331.317c8.341,8.341,8.341,21.824,0,30.165c-4.16,4.16-9.621,6.251-15.083,6.251c-5.461,0-10.923-2.091-15.083-6.251    l-75.413-75.435l-75.392,75.413c-4.181,4.16-9.643,6.251-15.083,6.251c-5.461,0-10.923-2.091-15.083-6.251    c-8.341-8.341-8.341-21.845,0-30.165l75.392-75.413l-75.413-75.413c-8.341-8.341-8.341-21.845,0-30.165    c8.32-8.341,21.824-8.341,30.165,0l75.413,75.413l75.413-75.413c8.341-8.341,21.824-8.341,30.165,0    c8.341,8.32,8.341,21.824,0,30.165l-75.413,75.413L361.461,331.317z"
              fill="#718096"
              data-original="#000000"
            ></path>
          </g>
        </svg>
      </button>
    </section>
  </div>
</template>

<script>
export default {
  name: "App",
  data() {
    return {
      seen: true,
      ticker: "", //создаю функцию дата, которая ретернит значение поля тикера по умолчанию как нул
      arr: ["1", "2", "3", "4"],
      currency: [
        // { name: "$", price: "73" },
        // { name: "@", price: "78" },
        // { name: "#", price: "70" }
      ], // массив из тикеров
      sel: null, //тестовая переменная - текущий тикер
      graph: [], //данные изменения курса
      page: 1, //текущая страница
      filterString: "", //дефолтная строка в инпуте фильтра
      hasNextPage: true //нужно дня понимания нужна ли кнопка "вперед" при пагинации или нет
      // в дата не долдно быть вычисляемых свойств, значения которых можно посчитать исходя из текущего состояния других переменных, находящихся в дата
    };
  },
  created() {
    const windowData = Object.fromEntries(
      new URL(window.location).searchParams.entries()
    ); //обжФромЭнтрайс - трансформит пары ключ значений сложенные в отдельные массивы по двое, в один объект с множеством лючей значений
    //урл делаем из виндоу локэйшна адрес, в который мы кладем встроенные методы это энтрайс(пары ключей значений) из параметров (серчПарамс- тоже встроенный метод) - фильтр и пэйдж

    if (windowData.filterString) {
      this.filterString = windowData.filterSting;

      if (windowData.page) {
        this.page = windowData.page;
      }
    }
    const tickersData = localStorage.getItem("crypto-list"); //достаем из локалстораджа тиекры (если они есть)
    if (tickersData) {
      this.currency = JSON.parse(tickersData);
      this.currency.forEach((el) => this.subscribeToUpdates(el.name));
    }
  },
  copmuted: {
    // startIndex() {
    //   return (this.page - 1) * 6;
    // },
    // endIndex() {
    //   return this.page * 6;
    // },
    // filteredCurrency() {
    //   // const start = (this.page - 1) * 6; // pagination in 6 element on 1 page
    //   // const end = this.page * 6; // алгоритм расчета пагинации на 6 элементов
    //   return this.currency.filter((el) => el.name.includes(this.filterString));
    //   // в copmuted  нельзя делать присваивание, поэтому выносим его в отдельный компьютед-метод
    //   // this.hasNextPage = filteredCurrency.length > end; // оставь кнопку вперед, если отфильтрованный массив больше последней страницы
    // },
    // paginatedCurrency() {
    //   return this.filteredCurrency.slice(this.startIndex, this.endIndex); // добавляем разделение на страницы
    // },
    // hasNextPage() {
    //   return this.filteredCurrency.length > this.endIndex;
    // },
    normalizedGraph() {
      //нужно для преобразование графика в более емкий вид, чтобы не растягивался на всю стр
      const maxValue = Math.max(...this.graph);
      const minValue = Math.min(...this.graph);
      if (maxValue === minValue) {
        return this.graph.map(() => 50); //если одинаковые значения, то выводи 50 одинаковых столбцов
      }
      return this.graph.map(
        (price) => 5 + ((price - minValue) * 95) / (maxValue - minValue)
      );
    }
  },
  methods: {
    filteredCurrency() {
      const start = (this.page - 1) * 6;
      const end = this.page * 6;

      const filteredCurrency = this.currency.filter((ticker) =>
        ticker.name.includes(this.filterString)
      );

      this.hasNextPage = filteredCurrency.length > end;

      return filteredCurrency.slice(start, end);
    },
    subscribeToUpdates(ticketName) {
      setInterval(async () => {
        const f = await fetch(
          `https://min-api.cryptocompare.com/data/price?fsym=${ticketName}&tsyms=USD&api_key=b48018a4e079c4983d2837f86d0657bf9f95ad8e6c3a0d29a2a0da01565ad9ea`
        );
        const data = await f.json();
        this.currency.find((t) => t.name === ticketName).price =
          data.USD > 1 ? data.USD.toFixed(2) : data.USD;

        if (this.sel?.name === ticketName) {
          this.graph.push(data.USD);
        }
      }, 5000), //выведи и обновляй каждые 5 сек прайс с апишки в выбранной валюте + преобразую к адекватному виду (2 знака после целых, 2 зачимых знака после нулевых) в посл тернарнике
        (this.ticker = ""); //clear input after adding
    },
    // add(e) {
    //   alert(e.key);
    // }
    add() {
      const newEl = {
        name: this.ticker,
        price: "-"
      };
      this.currency.push(newEl); //add new obj from input
      this.filterSting = ""; //при добавлении новых элемнетов сбрасывай фильтр
      localStorage.setItem("crypto-list", JSON.stringify(this.currency)); // скадываем данные в локалсторадж
      this.subscribeToUpdates(newEl.name);
    },

    select(elem) {
      (this.sel = elem), (this.graph = []); //при выборе элемента закинь его в сэл и очисть граф
    },
    deleteHandler(cur) {
      this.currency = this.currency.filter((el) => el !== cur); //удаляем элемент и вешаем его на онклик у "удалить"
    }
  },

  watch: {
    paginatedTickers() {
      if (this.paginatedCurrency.length === 0 && this.page > 1) {
        this.page -= 1;
      }
    }, //если на второй и далее страницах были удалены все тикеры, перейти на предыдущую страницу

    //следит за переменной в данном случае фильтерстринг, и когда она меняется, присвой  данном случае пэйджу значение 1 (оставь одну страницу с отфильтрованными элементами)
    filterSting() {
      this.page = 1;
      window.history.pushState(
        //histroy.pushState - встроеный метод объекта уиндоу с обязательными параметрами(гугл), будет изменять данные в алреснй строке, находять на опр странице пэйдж и применяя опр фильтры в фильтрСтринге
        null,
        document.title,
        `${window.location.pathname}?filter=${this.filterString}&page=${this.page}`
      );
    },
    page() {
      //аналогично отслеживанию фильтрстринга
      window.history.pushState(
        null,
        document.title,
        `${window.location.pathname}?filter=${this.filterString}&page=${this.page}`
      );
    }
  }
};
</script>
